


#include "defs.h"
#include "regs.h"
#include "hw.h"
#include "cpu.h"
#include "mem.h"
#include "lcd.h"
#include "rc.h"

#include "profiler.h"

static int framelen = 16743;
static int framecount;

rcvar_t emu_exports[] =
{
	RCV_INT("framelen", &framelen),
	RCV_INT("framecount", &framecount),
	RCV_END
};







void emu_init()
{
	
}


/*
 * emu_reset is called to initialize the state of the emulated
 * system. It should set cpu registers, hardware registers, etc. to
 * their appropriate values at powerup time.
 */

void emu_reset()
{
	hw_reset();
	lcd_reset();
	cpu_reset();
	mbc_reset();
	sound_reset();
}





void emu_step()
{
	cpu_emulate(cpu.lcdc);
}



/* This mess needs to be moved to another module; it's just here to
 * make things work in the mean time. */

void *sys_timer();

int userExit;
void emu_run()
{
	static int sCount = 0;
	void *timer = sys_timer();
	int delay;

	vid_begin();
	lcd_begin();
	userExit = 0;
	while (!userExit)
	{
		PROFILER_MARK(PROFILER_CPU_EMU1ST);
		cpu_emulate(2280);
		PROFILER_MARK(PROFILER_END);

		PROFILER_MARK(PROFILER_EMU_STEP1);
		while (R_LY > 0 && R_LY < 144)
			emu_step();
		PROFILER_MARK(PROFILER_END);
		
		PROFILER_MARK(PROFILER_EMU_STEP3);
		vid_end();
		rtc_tick();
		sound_mix();
		delay = pcm_submit() ? 0 : framelen - sys_elapsed(timer);
		/* printf("%d\n", delay); */
		sys_sleep(delay);
		sys_elapsed(timer);
		vid_begin();
		doevents();
		if (framecount) { if (!--framecount) die("finished\n"); }
		PROFILER_MARK(PROFILER_END);
		
		PROFILER_MARK(PROFILER_CPU_EMU2ND);
		if (!(R_LCDC & 0x80))
			cpu_emulate(32832);
		PROFILER_MARK(PROFILER_END);
		
		PROFILER_MARK(PROFILER_EMU_STEP2);
		while (R_LY > 0) /* wait for next frame */
			emu_step();
		PROFILER_MARK(PROFILER_END);

		if (++sCount == 5)
		{
			PROFILER_SHOW();
			sCount=0;
			vid_fps();
		}
	}
}

