

#include "defs.h"
#include "lcd.h"

#define BUF (scan.buf)

#ifdef USE_ASM
#include "asm.h"
#endif

__inline byte MAKE_2BPP_BYTE(byte c1, byte c2, byte c3, byte c4)
{
	return (c4 << 6) | (c3 << 4) | (c2 << 2) | (c1);
}

__inline byte MAKE_4BPP_BYTE(byte c1, byte c2)
{
	return (c2 << 4) | (c1);
}

void psion_refresh_2_double(byte *dest, byte *src, byte *pal, int cnt)
{
	cnt>>=2;
	while(cnt--)
	{
		byte	val = MAKE_2BPP_BYTE(pal[*(src++)], pal[*(src++)], pal[*(src++)], pal[*(src++)]);
		*(dest++) = val;
		*(dest++) = val;
	}
}

void psion_refresh_2(byte *dest, byte *src, byte *pal, int cnt)
{
	cnt>>=2;
	while(cnt--)
		*(dest++) = MAKE_2BPP_BYTE(pal[*(src++)], pal[*(src++)], pal[*(src++)], pal[*(src++)]);
}

void psion_refresh_4_double(byte *dest, byte *src, byte *pal, int cnt)
{
	cnt>>=1;
	while(cnt--)
	{
		byte	val = MAKE_4BPP_BYTE(pal[*(src++)], pal[*(src++)]);
		*(dest++) = val;
		*(dest++) = val;
	}
}

void psion_refresh_4(byte *dest, byte *src, byte *pal, int cnt)
{
	cnt>>=1;
	while(cnt--)
		*(dest++) = MAKE_4BPP_BYTE(pal[*(src++)], pal[*(src++)]);
}




void psion_refresh_8_double(byte *dest, byte *src, byte *pal, int cnt)
{
	while(cnt--)
	{
		byte	val = pal[*(src++)];
		*(dest++) = val;
		*(dest++) = val;
	}
}
void psion_refresh_8(byte *dest, byte *src, byte *pal, int cnt)
{
	while(cnt--)
		*(dest++) = pal[*(src++)];
}





#ifndef ASM_REFRESH_1
void refresh_1_double(byte *dest, byte *src, byte *pal, int cnt)
{
	while(cnt--)
	{
		byte	val = pal[*(src++)];
		*(dest++) = val;
		*(dest++) = val;
	}
}
void refresh_1(byte *dest, byte *src, byte *pal, int cnt)
{
	while(cnt--)
		*(dest++) = pal[*(src++)];
}
//void refresh_1(byte *dest, byte *src, byte *pal, int cnt)
//{
//	while(cnt--) *(dest++) = pal[*(src++)];
//}
#endif


#ifndef __WINS__
__declspec(naked) void test_refresh_1(byte *dest, byte *src, byte *pal, int cnt)
{
	asm ("stmfd	sp!, {lr}");
	asm("mov r3, r3, lsr #4");
	asm("loop:");

#if 0
	asm("ldrb	lr, [r1], #1");
	asm("ldrb	lr, [r2, lr]");
	asm("strb	lr, [r0], #1");

	asm("ldrb	lr, [r1], #1");
	asm("ldrb	lr, [r2, lr]");
	asm("strb	lr, [r0], #1");

	asm("ldrb	lr, [r1], #1");
	asm("ldrb	lr, [r2, lr]");
	asm("strb	lr, [r0], #1");

	asm("ldrb	lr, [r1], #1");
	asm("ldrb	lr, [r2, lr]");
	asm("strb	lr, [r0], #1");
#endif
	asm("ldr	lr, [r1], #4");
	asm("str	lr, [r0], #4");

	asm("ldr	lr, [r1], #4");
	asm("str	lr, [r0], #4");

	asm("ldr	lr, [r1], #4");
	asm("str	lr, [r0], #4");

	asm("ldr	lr, [r1], #4");
	asm("str	lr, [r0], #4");

	asm("subs	r3, r3, #1");
	asm("bne	loop");
	asm("ldmfd	sp!, {pc}");
}
#endif


#ifndef ASM_REFRESH_2
void refresh_2(un16 *dest, byte *src, un16 *pal, int cnt)
{
	while (cnt--) *(dest++) = pal[*(src++)];
}
#endif

#ifndef ASM_REFRESH_3
void refresh_3(byte *dest, byte *src, un32 *pal, int cnt)
{
	un32 c;
	while (cnt--)
	{
		c = pal[*(src++)];
		*(dest++) = c;
		*(dest++) = c>>8;
		*(dest++) = c>>16;
	}
}
#endif

#ifndef ASM_REFRESH_4
void refresh_4(un32 *dest, byte *src, un32 *pal, int cnt)
{
	while (cnt--) *(dest++) = pal[*(src++)];
}
#endif




#ifndef ASM_REFRESH_1_2X
void refresh_1_2x(byte *dest, byte *src, byte *pal, int cnt)
{
	byte c;
	while (cnt--)
	{
		c = pal[*(src++)];
		*(dest++) = c;
		*(dest++) = c;
	}
}
#endif

#ifndef ASM_REFRESH_2_2X
void refresh_2_2x(un16 *dest, byte *src, un16 *pal, int cnt)
{
	un16 c;
	while (cnt--)
	{
		c = pal[*(src++)];
		*(dest++) = c;
		*(dest++) = c;
	}
}
#endif

#ifndef ASM_REFRESH_3_2X
void refresh_3_2x(byte *dest, byte *src, un32 *pal, int cnt)
{
	un32 c;
	while (cnt--)
	{
		c = pal[*(src++)];
		dest[0] = dest[3] = c;
		dest[1] = dest[4] = c>>8;
		dest[2] = dest[5] = c>>16;
		dest += 6;
	}
}
#endif

#ifndef ASM_REFRESH_4_2X
void refresh_4_2x(un32 *dest, byte *src, un32 *pal, int cnt)
{
	un32 c;
	while (cnt--)
	{
		c = pal[*(src++)];
		*(dest++) = c;
		*(dest++) = c;
	}
}
#endif

#ifndef ASM_REFRESH_2_3X
void refresh_2_3x(un16 *dest, byte *src, un16 *pal, int cnt)
{
	un16 c;
	while (cnt--)
	{
		c = pal[*(src++)];
		*(dest++) = c;
		*(dest++) = c;
		*(dest++) = c;
	}
}
#endif

#ifndef ASM_REFRESH_3_3X
void refresh_3_3x(byte *dest, byte *src, un32 *pal, int cnt)
{
	un32 c;
	while (cnt--)
	{
		c = pal[*(src++)];
		dest[0] = dest[3] = dest[6] = c;
		dest[1] = dest[4] = dest[7] = c>>8;
		dest[2] = dest[5] = dest[8] = c>>16;
		dest += 9;
	}
}
#endif

#ifndef ASM_REFRESH_4_3X
void refresh_4_3x(un32 *dest, byte *src, un32 *pal, int cnt)
{
	un32 c;
	while (cnt--)
	{
		c = pal[*(src++)];
		*(dest++) = c;
		*(dest++) = c;
		*(dest++) = c;
	}
}
#endif

#ifndef ASM_REFRESH_3_4X
void refresh_3_4x(byte *dest, byte *src, un32 *pal, int cnt)
{
	un32 c;
	while (cnt--)
	{
		c = pal[*(src++)];
		dest[0] = dest[3] = dest[6] = dest[9] = c;
		dest[1] = dest[4] = dest[7] = dest[10] = c>>8;
		dest[2] = dest[5] = dest[8] = dest[11] = c>>16;
		dest += 12;
	}
}
#endif

#ifndef ASM_REFRESH_4_4X
void refresh_4_4x(un32 *dest, byte *src, un32 *pal, int cnt)
{
	un32 c;
	while (cnt--)
	{
		c = pal[*(src++)];
		*(dest++) = c;
		*(dest++) = c;
		*(dest++) = c;
		*(dest++) = c;
	}
}
#endif

