/*******************************************************************
 *
 *	File:		GbMain.cpp
 *
 *	Author:		Peter van Sebille (peter@yipton.demon.co.uk)
 *
 *	(c) Copyright 2001, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/


#include <stdio.h>
#include <unistd.h>
#include <e32std.h>
#include <f32file.h>
#include <e32svr.h>
#include <estlib.h>
#include <eikdll.h>
#include <w32std.h>


#include "GnuBoy.h"
#include "game.h"
#include "GlobalData.h"
#include "platform.h"

static RChunk			sGlobalDataChunk;


TBool IsGameAppRunning()
{
	TInt err = sGlobalDataChunk.OpenGlobal(KGlobalDataChunkName, EFalse);
	if (err == KErrNone)
		sGlobalDataChunk.Close();
	return (err == KErrNone);
}


void EpocGameL(int argc, char* argv[])
{
#ifdef __WINS__
	int crt_argc=0;
	char** crt_argv=0;
	char** crt_envp=0;

	__crt0(crt_argc, crt_argv, crt_envp);
#endif
	printf(" ");
	fflush(stdout);

	gameboy_main(argc, argv);

#ifdef __WINS__
	RThread	me;
#else
	RProcess	me;
	me.Terminate(0);
#endif

#ifdef __WINS__
	fclose(stdin);
	fclose(stdout);
	fclose(stderr);
#endif
}




#ifdef __WINS__

EXPORT_C void EntryRunGame(int argc, char* argv[])
{
	EpocGameL(argc, argv);
}


int __cdecl E32Dll(TDllReason aReason)
{
	return(KErrNone);
}

int main(int argc, char* argv[])
{
	DEBUGGER();
	return 0;
}



#else

#define APP_ON_C "C:\\EGNUBOY\\APP\\GBAPP.APP"
#define APP_ON_D "D:\\EGNUBOY\\APP\\GBAPP.APP"


void StartGameAppL()
{
	CApaCommandLine* apaCommandLine = CApaCommandLine::NewLC();
	if (access(APP_ON_D, 0) != -1)
		apaCommandLine->SetLibraryNameL(_L(APP_ON_D));
	else
		apaCommandLine->SetLibraryNameL(_L(APP_ON_C));

	CleanupStack::Pop();
	EikDll::StartAppL(*apaCommandLine);
}


void TargetEpocGameL(int argc, char* argv[])
{
	if (argc == 1)
	{
		if (!IsGameAppRunning())
			StartGameAppL();
		else
			User::InfoPrint(_L("Gameboy is already running"));
		return;
	}

	EpocGameL(argc, argv);
}


int TargetGame(int argc, char* argv[])
{
	CTrapCleanup* cleanup=CTrapCleanup::New();

	TRAPD(error, TargetEpocGameL(argc, argv));

	__ASSERT_ALWAYS(!error, User::Panic(_L("GAMEBOY"), error));

	delete cleanup;

	return 0;
}


extern "C" {
int main(int argc, char* argv[])
{
	TargetGame(argc, argv);

	return 0;
}
}		// extern "C"

#endif

